/* -*- pftp-c -*- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <string.h>
#include <pftputil.h>

#include "hpanes.h"
#include "support.h"
#include "globals.h"

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

static int last_pos[2] = { 0, 0 };

void setHPanes(GtkWidget *widget, unsigned short pos1, unsigned short pos2)
{
    GdkRectangle rect;
    
    if (pos1 > 0 && pos1 < 100) {
	global_config->horzpan1 = pos1;
    } else {
	global_config->horzpan1 = 50;
    }
    if (pos2 > 0 && pos2 < 100) {
	global_config->horzpan2 = pos2;
    } else {
	global_config->horzpan2 = 50;
    }
    
    last_pos[0] = 0;
    last_pos[1] = 0;
    gtk_window_get_size(GTK_WINDOW(widget), &rect.width, &rect.height);
    updateHPanes(widget, &rect);
}

void updateHPanes(GtkWidget *widget, GdkRectangle *rect)
{
    int pos1, pos2, cur1, cur2;
    GtkPaned *p1, *p2;
    
    pos1 = (int)((float)(rect->width * global_config->horzpan1) / 100.0f);
    pos2 = (int)((float)(rect->width * global_config->horzpan2) / 100.0f);
    p1 = GTK_PANED(lookup_widget(widget, "hpaned1"));
    p2 = GTK_PANED(lookup_widget(widget, "hpaned2"));  
    cur1 = gtk_paned_get_position(p1);
    cur2 = gtk_paned_get_position(p2);
    
    if (!last_pos[0] || (cur1 == last_pos[0] && last_pos[0] != pos1)) {
	gtk_paned_set_position(p1, pos1);
	last_pos[0] = pos1;
    } else if (pos1 != cur1) {
	global_config->horzpan1 = ((float)cur1 * 100.0f) / (float)rect->width; 
	last_pos[0] = cur1;    
    }
    
    if (!last_pos[1] || (cur2 == last_pos[1] && last_pos[1] != pos2)) {
	gtk_paned_set_position(p2, pos2);
	last_pos[1] = pos2;
    } else if (pos2 != cur2) {
	global_config->horzpan2 = ((float)cur2 * 100.0f) / (float)rect->width; 
	last_pos[1] = cur2;    
    }
}
