/* -*- pftp-c -*- */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <inttypes.h>
#include "support.h"
#include "messagebox.h"
#include "globals.h"
#include "str.h"

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

// From main.c
extern GtkWidget *main_window;

GtkResponseType messageBox(GtkWindow *parent, GtkDialogFlags flags,
			   GtkMessageType type, GtkButtonsType buttons,
			   const char *format, ...)
{
    GtkResponseType ret;
    GtkWidget *dlg;
    va_list list;
    size_t newformatlen;
    char *newformat;

    va_start(list, format);

    newformatlen = 1024 + strlen(format);
    newformat = malloc(newformatlen + 1);

    vsnprintf(newformat, newformatlen, format, list);
    newformat[newformatlen] = '\0';

    if (parent == NULL)
	parent = GTK_WINDOW(main_window);
        
    dlg = gtk_message_dialog_new(parent, flags, type, buttons, newformat);
    ret = gtk_dialog_run(GTK_DIALOG(dlg));
    gtk_widget_destroy(dlg);

    free(newformat);
    va_end(list);
    
    return ret;
}

