/* -*- pftp-c -*- */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <string.h>
#include <unistd.h>

#include "statusbar.h"

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

struct statusbar_s {
    GtkLabel *text0, *text1, *text2;
    GtkProgressBar *prog1, *prog2;
};

statusbar_t initStatusBar(GtkLabel *text0, GtkProgressBar *prog1, 
			  GtkLabel *text1, GtkProgressBar *prog2,
			  GtkLabel *text2)
{
    statusbar_t ret = malloc(sizeof(struct statusbar_s));
    memset(ret, 0, sizeof(struct statusbar_s));
    
    ret->text0 = text0;
    ret->text1 = text1;
    ret->text2 = text2;
    ret->prog1 = prog1;
    ret->prog2 = prog2;
    
    return ret;
}

void freeStatusBar(statusbar_t status)
{
    if (status) {
	free(status);
    }
}

void updateStatusBar(statusbar_t status, const char *text0,
		     int prog1, const char *text1, int prog2,
		     const char *text2)
{
    if (text0) {
	gtk_label_set_text(status->text0, text0);
    }
    
    if (text1) {
	gtk_label_set_text(status->text1, text1);
    }
    
    if (text2) {
	gtk_label_set_text(status->text2, text2);
    }
    
    if (prog1 >= 0 && prog1 <= 100) {
	gtk_progress_bar_set_fraction(status->prog1, (double)prog1 / 100.0);
    } else if (prog1 == 666) {
	gtk_progress_bar_pulse(status->prog1);
    }
    
    if (prog2 >= 0 && prog2 <= 100) {
	gtk_progress_bar_set_fraction(status->prog2, (double)prog2 / 100.0);
    } else if (prog2 == 666) {
	gtk_progress_bar_pulse(status->prog2);
    }    
}
